/*
 * This file is part of the EasyLogger Library.
 *
 * Copyright (c) 2015, Armink, <armink.ztl@gmail.com>
 *
 * Permission is hereby granted, free of charge, to any person obtaining
 * a copy of this software and associated documentation files (the
 * 'Software'), to deal in the Software without restriction, including
 * without limitation the rights to use, copy, modify, merge, publish,
 * distribute, sublicense, and/or sell copies of the Software, and to
 * permit persons to whom the Software is furnished to do so, subject to
 * the following conditions:
 *
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
 * IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
 * CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
 * TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 * SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 * Function: Portable interface for each platform.
 * Created on: 2015-04-28
 */

#include <stdio.h>
#include "main.h"
#include "elog.h"
#include "FreeRTOS.h"
#include "task.h"
#include "semphr.h"

static SemaphoreHandle_t elog_lock = NULL;
SemaphoreHandle_t elog_async = NULL;
SemaphoreHandle_t elog_dma_lock = NULL;

/**
 * EasyLogger port initialize
 *
 * @return result
 */
ElogErrCode elog_port_init(void)
{
    elog_lock = xSemaphoreCreateBinary();
    elog_async = xSemaphoreCreateBinary();
    elog_dma_lock = xSemaphoreCreateBinary();

    xSemaphoreGive(elog_lock);

    return ELOG_NO_ERR;
}

/**
 * EasyLogger port deinitialize
 *
 */
void elog_port_deinit(void)
{
    /* not implemented */
}

/**
 * output log port interface
 *
 * @param log output of log
 * @param size log size
 */
void elog_port_output(const char *log, size_t size)
{
    HAL_UART_Transmit_DMA(&huart1, (uint8_t *) log, size);

    if (xPortIsInsideInterrupt() == pdFALSE) {
        xSemaphoreTake(elog_dma_lock, portMAX_DELAY);
    } else {
        BaseType_t need_yield = pdFALSE;
        xSemaphoreTakeFromISR(elog_dma_lock, &need_yield);
        portYIELD_FROM_ISR(need_yield);
    }
}

/**
 * output lock
 */
void elog_port_output_lock(void)
{
    if (xPortIsInsideInterrupt() == pdFALSE) {
        xSemaphoreTake(elog_lock, portMAX_DELAY);
    } else {
        BaseType_t need_yield = pdFALSE;
        xSemaphoreTakeFromISR(elog_lock, &need_yield);
        portYIELD_FROM_ISR(need_yield);
    }
}

/**
 * output unlock
 */
void elog_port_output_unlock(void)
{
    if (xPortIsInsideInterrupt() == pdFALSE) {
        xSemaphoreGive(elog_lock);
    } else {
        BaseType_t need_yield = pdFALSE;
        xSemaphoreGiveFromISR(elog_lock, &need_yield);
        portYIELD_FROM_ISR(need_yield);
    }
}

/**
 * get current time interface
 *
 * @return current time
 */
const char *elog_port_get_time(void)
{
    static char str_sys_tick[20];
    uint32_t ticks = xTaskGetTickCountFromISR();

    snprintf(str_sys_tick, 20, "%d.%03d", (int)(ticks / 1000), (int)(ticks % 1000));

    return str_sys_tick;
}

/**
 * get current process name interface
 *
 * @return current process name
 */
const char *elog_port_get_p_info(void)
{
    return "";
}

/**
 * get current thread name interface
 *
 * @return current thread name
 */
const char *elog_port_get_t_info(void)
{
    return "";
}

void elog_async_output_notice(void)
{
    if (xPortIsInsideInterrupt() == pdFALSE) {
        xSemaphoreGive(elog_async);
    } else {
        BaseType_t need_yield = pdFALSE;
        xSemaphoreGiveFromISR(elog_async, &need_yield);
        portYIELD_FROM_ISR(need_yield);
    }
}
